/*
 * ** PIR Private Directory Service prototype
 * ** Copyright (C) 2002 Alexander Iliev <iliev@nimbus.dartmouth.edu>
 * **
 * ** This program is free software; you can redistribute it and/or modify
 * ** it under the terms of the GNU General Public License as published by
 * ** the Free Software Foundation; either version 2 of the License, or
 * ** (at your option) any later version.
 * **
 * ** This program is distributed in the hope that it will be useful,
 * ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 * ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * ** GNU General Public License for more details.
 * **
 * ** You should have received a copy of the GNU General Public License
 * ** along with this program; if not, write to the Free Software
 * ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * */

/* -*- c++ -*-
 * card/hostcall.h
 * alex iliev, nov 2002
 */

#include <common/hostcall.h>
#include <common/exceptions.h>

#include <common/utils.h>


//
// the user functions for various services
//
host_status_t host_fetch_record (const record_id& id,
				 encrypted_record & o_result);

host_status_t host_fetch_clearrecord (const record_id&,
				      Record & o_result);

host_status_t host_write_record (const named_record&);


//
// the function which will be used to invoke services on the host
//
host_status_t invoke_host (host_service_id_t service,
			   const ByteBuffer& params,
			   ByteBuffer& o_result);
