/*
 * ** PIR Private Directory Service prototype
 * ** Copyright (C) 2002 Alexander Iliev <iliev@nimbus.dartmouth.edu>
 * **
 * ** This program is free software; you can redistribute it and/or modify
 * ** it under the terms of the GNU General Public License as published by
 * ** the Free Software Foundation; either version 2 of the License, or
 * ** (at your option) any later version.
 * **
 * ** This program is distributed in the hope that it will be useful,
 * ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 * ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * ** GNU General Public License for more details.
 * **
 * ** You should have received a copy of the GNU General Public License
 * ** along with this program; if not, write to the Free Software
 * ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * */

// card/lib.h  -*-c++-*-
// alex iliev jan 2003
// some shared routines for the card

#ifndef _CARD_LIB_H
#define _CARD_LIB_H

#include <string>
#include <vector>

#include <common/utils.h>


// instantiated in lib.cc
// FIXME: make these dynamic
extern const size_t BUCKETSIZE;
extern const size_t DBSIZE;

extern const char SHUFFLE_FILE[];


void
loadkeys (byte * key, const std::string& keyfile,
	  byte * mackey, const std::string& mackeyfile)
    throw (std::ios::failure);
    
    
void load_shuffle (std::vector<index_t>& V, const std::string& filename)
    throw (std::ios::failure);

std::string get_shuffle_filename ();
    
//
// split up a record ciphertext into the MAC part, and ciphertext part
//
ByteBuffer getmac (const ByteBuffer& buf);
ByteBuffer getcipher (const ByteBuffer& buf);

//
// combine a ciphertext and mac into one (reverse of the above two functions)
ByteBuffer addmac (const ByteBuffer& ciphertext, const ByteBuffer& mac);



#endif /* _CARD_LIB_H */
