## Copyright (C) 2002 Alexander Iliev <iliev@nimbus.dartmouth.edu>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#!/usr/bin/perl -w

use English;
use IPC::Open2;


$DIR="$ENV{HOME}/work/shib/code/host";
$PIRSEARCH="$DIR/pirsearch";
$CARDNO = 1;

#open LOG, ">$DIR/pir-query.log" or die "opening log: $ERRNO";


# read the operation requested. should be SEARCH
my $op = <>; chomp $op;
if ($op ne 'SEARCH') { die "Wrong operation: $op"; }


# read the parameters from LDAP, which are a tag name followed by a space and
# the tag value

my %req;
while (<>) {
  chomp;

  # lines are of the form
  # tag: value
  my ($tag, $value) = /([[:lower:]]+): (.*)/;
  $req{$tag} = $value
    if defined $tag and defined $value;

}


# open the actual PIR program
my($pid, $pirout, $pirin);
eval {
  $pid = open2 ($pirout, $pirin, $PIRSEARCH, $CARDNO);
};

die "open2 pir: $EVAL_ERROR" if $EVAL_ERROR =~ /^open2:/;


# what are we searching for - write it to the search program
my ($target) = $req{filter} =~ /\(.*=(.*)\)/;
print $pirin $target, "\n";

# read the record name
my $recname = <$pirout>; chomp $recname;

print <<EOF;
dn: cn=$recname,$req{base}
objectclass: top
objectclass: person
cn: $recname
EOF

# and now read the name-value attribute list and print it
my ($name, $value);
while (defined ($name  = <$pirout>) and
       defined ($value = <$pirout>))
  {
    chomp ($name, $value);
    print "$name: $value\n";
  }

# print the closing comments. note the blank line in there
print<<EOF;

RESULT
code: 0
EOF

waitpid $pid, 0;

close LOG;

